
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Decomposition of REAL GNP into random walk (stochastic trend) component
vs. stationary (cyclical) component
Model:
 
cjkim@korea.ac.kr
WRITTEN BY C.J. KIM, DEPT. OF ECONOMICS, KOREA UNIVERSITY
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */


new;
library  optmum, pgraph;

format /m1 /rd 9,6;
  load data1[195,1]=gdp4795.prn;
  load data2[195,1]=lhur.prn;
  load data3[195,1]=gd4795.prn;



yy1= LN(data1[5:195,1]);
yy2= data2[5:195,1]/100;

dy1=yy1[2:191,1]-yy1[1:190,1];
dy2=yy2[2:191,1]-yy2[1:190,1];

yy=yy1'|yy2';
t=cols(yy); @191@





@ Maximum Likelihood Estimation @


START=21-4;  @1951.I @

PRMTR_IN={ 3.056895  2.693567  5.635313  2.351464  2.355202 -0.335523
  -0.175425 0.0  4.328002  5.350932 };

prmtr_in={ 3.023545  2.706035  5.825777  2.560661  2.564257 -0.336789 -0.163511
-0.072012  4.187827  5.790596 };

PRMTR_IN=PRMTR_IN';

                     @Initial values of the parameters @

/*

 {xout,fout,gout,cout}=optmum(&lik_fcn,PRMTR_IN);
                     @ prmtr estimates, -log lik value, Grandient, code@

prm_fnl=trans(xout);

"Calculating Hessian..... Please be patient!!!!";
                  hessn0=hessp(&lik_fcn,xout);
                  cov0=inv(hessn0);

grdn_fnl=gradfd(&TRANS,xout);
cov=grdn_fnl*cov0*grdn_fnl';
SD =sqrt(diag(cov)); @Standard errors of the estimated coefficients@


output file=clrk_bi.out reset;

"==FINAL OUTPUT========================================================";
"initial values of prmtr is";
                 trans(prmtr_in)';
"==============================================================";
"likelihood value is ";; -fout;
"code";;cout;
"Estimated parameters are:";
prm_fnl';
XOUT';
"Standard errors of parameters are:"; sd';
OUTPUT OFF;
*/

/* Don't forget to delete the following line when you estimate the
parameters.*/
xout=prmtr_in;


DATA = filter(xout);

output file=clrk_bi.dta reset;
yy[.,start:t]'~DATA;
output off;

XY(SEQA(1,1,ROWS(DATA)),YY[1,START:T]'~DATA[.,1]);
XY(SEQA(1,1,ROWS(DATA)),DATA[.,2]~zeros(rows(data),1));
XY(SEQA(1,1,ROWS(DATA)),DATA[.,3]);
XY(SEQA(1,1,ROWS(DATA)),YY[2,START:T]'~DATA[.,4]);
XY(SEQA(1,1,ROWS(DATA)),(YY[2,START:T]'-DATA[.,4])~zeros(rows(data),1));

@ END OF MAIN PROGRAM @
@========================================================================@
@========================================================================@




PROC LIK_FCN(PRMTR1);

     LOCAL SV,SE,F,H,Q,R,BETA_LL,P_LL,BETA_TL,P_TL,BETA_TT,P_TT,vt,ft, VAL,
     LIK_MAT,J_ITER, phi1,phi2,vecpll,prmtr,mu,SW,d0,d1,d2,d3,sv_un,se_un,
     cov_ve;


     PRMTR=TRANS(PRMTR1);

LOCATE 20,1;  PRMTR';

     SV=PRMTR[1,1];  @s.e. of the random walk component@
     SE=PRMTR[2,1];  @s.e. of the AR component@
     SW=PRMTR[3,1];
     phi1=prmtr[4,1];
     phi2=prmtr[5,1];

     d0=prmtr[6,1];
     d1=prmtr[7,1];
     d2=prmtr[8,1];

     sv_un=prmtr[9,1];
     se_un=prmtr[10,1];
     cov_ve=0;

      F=(1~0   ~0   ~0~1~0)|
        (0~phi1~phi2~0~0~0)|
        (0~1   ~0   ~0~0~0)|
        (0~0~   1   ~0~0~0)|
        (0~0~   0   ~0~1~0)|
        (0~0~   0   ~0~0~1);


     H=(1~1~0~0~0~0)|
       (0~d0~d1~d2~0~1);

     Q= ZEROS(6,6);

              Q[1,1]=SV^2; Q[2,2]=SE^2;  Q[5,5]=SW^2;
              Q[6,6]=sv_un^2;

     R= (0~0)|
        (0~se_un^2);


     BETA_LL=zeros(6,1);
     P_LL=EYE(6)*100;

     LIK_MAT=ZEROS(T,1);

J_ITER = 1;
DO UNTIL J_ITER>T;

      BETA_TL = F * BETA_LL ;
      P_TL = F * P_LL * F' + Q;

      vt=yy[.,j_iter] - H * BETA_TL ; @prediction error@

      ft= H * P_TL * H' + R;       @variance of forecast error@


      BETA_TT= BETA_TL + P_TL * H' * inv(ft) * vt;
      P_TT= P_TL - P_TL * H' * inv(ft) * H * P_TL;

      LIK_MAT[J_ITER,1] =  0.5*(LN(2*pi*det(ft)) + vt'inv(ft)*vt);

      BETA_LL=BETA_TT;
      P_LL=P_TT;


J_ITER = J_ITER+1;
ENDO;

VAL = SUMC(LIK_MAT[START:T]);

LOCATE 2,20;  VAL;

RETP(VAL);
ENDP;


@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@

PROC FILTER(PRMTR1);

     LOCAL SV,SE,F,H,Q,R,BETA_LL,P_LL,BETA_TL,P_TL,BETA_TT,P_TT,
     vt,ft, VAL, LIK_MAT,J_ITER,
     phi1,phi2,vecpll,prmtr,mu,SW,BETA_MAT,d0,d1,d2,d3,sv_un,se_un,
     cov_ve;

     BETA_MAT=ZEROS(T,4);

     PRMTR=TRANS(PRMTR1);

LOCATE 20,1;  PRMTR';


     SV=PRMTR[1,1];  @s.e. of the random walk component@
     SE=PRMTR[2,1];  @s.e. of the AR component@
     SW=PRMTR[3,1];
     phi1=prmtr[4,1];
     phi2=prmtr[5,1];

     d0=prmtr[6,1];
     d1=prmtr[7,1];
     d2=prmtr[8,1];

     sv_un=prmtr[9,1];
     se_un=prmtr[10,1];
     cov_ve=0;

      F=(1~0   ~0   ~0~1~0)|
        (0~phi1~phi2~0~0~0)|
        (0~1   ~0   ~0~0~0)|
        (0~0~   1   ~0~0~0)|
        (0~0~   0   ~0~1~0)|
        (0~0~   0   ~0~0~1);


     H=(1~1~0~0~0~0)|
       (0~d0~d1~d2~0~1);

     Q= ZEROS(6,6);

              Q[1,1]=SV^2; Q[2,2]=SE^2;  Q[5,5]=SW^2;
              Q[6,6]=sv_un^2;

     R= (0~0)|
        (0~se_un^2);


     BETA_LL=zeros(6,1);
     P_LL=EYE(6)*100;



J_ITER = 1;
DO UNTIL J_ITER>T;



      BETA_TL = F * BETA_LL ;
      P_TL = F * P_LL * F' + Q;

      vt=yy[.,j_iter] - H * BETA_TL ;
                  @prediction error@

      ft= H * P_TL * H' + R;       @variance of forecast error@


      BETA_TT= BETA_TL + P_TL * H' * inv(ft) * vt;
      P_TT= P_TL - P_TL * H' * inv(ft) * H * P_TL;


BETA_MAT[J_ITER,.]=BETA_TT[1,1]~BETA_TT[2,1]~BETA_TT[5,1]~beta_tt[6,1];

      BETA_LL=BETA_TT;
      P_LL=P_TT;


J_ITER = J_ITER+1;
ENDO;


RETP(BETA_MAT[START:T,.]);
ENDP;


@================================================================@
PROC TRANS(c0); @ constraining values of reg. coeff.@
         local c1,d1,d2;

         c1=c0;
         c1[1:3,.]=exp(-1*c0[1:3,.])/10;

        d1=c0[4,1]./(1+abs(c0[4,1]));
     d2=c0[5,1]./(1+abs(c0[5,1]));

     c1[4,1]=d1+d2;
     c1[5,1]= -1* d1*d2 ;

         c1[9:10,.]=exp(-1*c0[9:10,.])/10;
@         c1[12,1]=c0[12,1]/(1+abs(c0[12,1]));@

retp(c1);
endp;

