/* ST2.OPT:
            WRITTEN BY CHANG-JIN KIM,
        FOR KIM AND KIM (1996, FORTHCOMING IN THE
            JOURNAL OF APPLIED ECONOMETRICS)

cjkim@korea.ac.kr
     ///////////   */

new;
library optmum,pgraph;
#include optmum.ext;
optset;

format /m1 /rd 12,6;
prgstr="STOCK1.OPT 1952:01-1987:12";

load data[804,2]=rsp2692.prn;      @Month index and  real S&P index, in logs@

@        beginDat=1;@
 
    beginDat=313;    @1952.1--1992.12@

yy0= data[beginDat:804,2];




/*graphset;
XAA = SEQA(1,1,ROWS(YY));
XY(XAA,YY);*/

 t0=rows(yy0);
yy=yy0[2:t0]-yy0[1:t0-1];
       yy_org=yy0[2:t0];
t=rows(yy);

xy(seqa(1,1,rows(yy)),yy);

output file=st2.out reset;

"=============================================================";
output off;

     @================= Initialize Global Variables============@


start=1;
jj_iter=1;

           PRMTR_NO=11;   @ >>Number of parameters to be estimated. >>@
           dm=2;        @ >> dimension of transition equation >>@


       @ ========  PPR1=PRMTR[1,1];    Pr[S1t=1,S1tl=1]
                   QPR1=PRMTR[2,1];    Pr[S1t=0,S1tl=0]
                   PPR2=PRMTR[3,1];    Pr[S2t=1,S2tl=1]
                   QPR2=PRMTR[4,1];    Pr[S2t=0,S2tl=0]
                   SV0=PRMTR[5,1];  S.E. OF PERMANENT SHOCK(S1=0)
                   SE0=PRMTR[6,1];  S.E. OF TRANSITORY SHOCK(S2=0)
                   AV0=PRMTR[7,1];  S.E. OF PERMANENT  SHOCK(S1=1)
                   AE0=PRMTR[8,1];  S.E. OF TRANSITORY SHOCK(S2=1)
                   AR1=PRMTR[9,1];
                   AR2=PRMTR[10,1];
                   mu=prmtr[11,1];
                            ==========================@

                           @initial values of parameters@

  prmtr_in= 4.06033|2.65278|1.08407|4.57705|3.79506|3.79431|3.22417|
           2.27929|1.1| 2|0.00436;

prmtr_in=4.19683|2.62288|2.62|4.3136|3.756434|4.30|3.18|
         2.2042|1.16|1.165|0.002336;


           prmtr_i0=prmtr_in;
           xout=zeros(prmtr_no,1);

output on;
"          initial values of parameters are ";
PRMTR_IN';
" ";


"       ========================================================";
output off;

@ Maximum Likelihood Estimation @
@==================================================@

__title=prgstr;

 {xout,fout,gout,cout}=optmum(&lik_fcn,PRMTR_IN);
                     @ prmtr estimates, -log lik value, Grandient, code@

PRM_FNL=TRANS(xout);   @ Estimated  coefficients, constrained@
prm_11=prm_fnl; save prm_11;
output on;
"==FINAL OUTPUT========================================================";
"initial values of prmtr is";
                  prmtr_i0';
"==============================================================";
"likelihood value is ";; fout;
"code";;cout;
"Estimated parameters are:";
prm_fnl';     "====";XOUT'; OUTPUT OFF;

            "Calculating Hessian..... Please be patient!!!!";
                  hout=inv(hessp(&lik_fcn,xout));
        grdn_fnl=gradp(&TRANS,xout);
                Hsn_fnl=grdn_fnl*hout*grdn_fnl';
                SD_fnl =sqrt(diag(Hsn_fnl));
                       @Standard errors of the estimated coefficients@
OUTPUT ON;
"Standard errors of parameters are:"; sd_fnl';
"var-cov matrix is:"; Hsn_fnl;    OUTPUT OFF;
"===============================================================";
/*
{cycle,prst1,prst2,ratio}=LIK_OUT(prm_fnl);
trend = yy_org-cycle;

*/
@ END OF MAIN PROGRAM @
@========================================================================@
@========================================================================@
PROC LIK_FCN(PRMTR1);

LOCAL PPR1,PPR2,QPR1,QPR2,PHI,SV0,SE0,AV0,AE0,DD,BETA1,BETA2,AAA,H,PRO1__1,
      PRO1__0,PRO2__0,PRO2__1,P_C12_,P_C12_00,P_C12_01,P_C12_10,P_C12_11,
      P_V12_,P_V12_00,P_V12_01,P_V12_10,P_V12_11,SV_M,SE_M,PST_CF,PST_VR,
      F_CAST,SS,K_GN,P_CF,P_VR,PR_VL,LIKV,J_ITER,J,LIK,S1t,S2t,S1tl,S2tl,
      PR_VAL,PRO_,PRO1_00,PRO1_01,PRO1_10,PRO1_11,PRO2_00,PRO2_01,PRO2_10,
      PRO2_11,PRO12_00,PRO12_01,PRO12_10,PRO12_11,PRMTR,PR_TR1,PR_TR2,
      PRO2__,PRO1__,DD1,DD2,DD3,DD4,MU,MU_L,AR1,AR2,QQ,QQ_S,PRIOR_VR,VECP,
      mu_m,QQ_ss,vecp,prior_vr;

EXTERNAL PROC TRANS, V_PROB;


PRMTR=TRANS(PRMTR1);
LOCATE 15,1; PRMTR';

PPR1=PRMTR[1,1];    @Pr[St=1/St-1=1]@
QPR1=PRMTR[2,1];    @Pr[St=0/St-1=0]@
PPR2=PRMTR[3,1];
QPR2=PRMTR[4,1];
SV0=PRMTR[5,1];
SE0=PRMTR[6,1];
AV0=PRMTR[7,1];
AE0=PRMTR[8,1];
AR1=PRMTR[9,1];
AR2=PRMTR[10,1];
mu=prmtr[11,1];

mu_m=mu;


AAA=(ar1~ar2)|
    (1  ~0  );
H=1~-1;

@>>>>>>>>>>>>>>>>>>>>>>>>>  INITIAL PROB. Pr[S0/Y0] @

        PRO1__1=(1-QPR1)/(2-PPR1-QPR1);   @Pr[St-1=1/Yt-1], STEADY STATE PROB.@
        PRO1__0=1-PRO1__1  ;           @Pr[ST-1=0/Yt-1], STEADY STATE PROB @

        PRO2__1=(1-QPR2)/(2-PPR2-QPR2);   @Pr[St-1=1/Yt-1], STEADY STATE PROB.@
        PRO2__0=1-PRO2__1  ;           @Pr[ST-1=0/Yt-1], STEADY STATE PROB @

SV_M=(SV0^2~AV0^2);
SE_M=(SE0^2~AE0^2);

P_C12_00=zeros(dM,1);
P_C12_01=ZEROS(DM,1);
P_C12_10=ZEROS(DM,1);
P_C12_11=ZEROS(DM,1);


         QQ_ss=  ((se0^2*pro2__0 + ae0^2*pro2__1)~0)|(0~0);
         vecp=inv(eye(4)-aaa.*.aaa)*vec(QQ_ss);
     prior_vr=vecp[1:2,1]~vecp[3:4,1];

  P_V12_00=prior_vr;
  P_V12_01=prior_vr;
  P_V12_10=prior_vr;
  P_V12_11=prior_vr;


PST_CF=ZEROS(DM,16);
PST_VR=ZEROS(DM,16*DM);

F_CAST=ZEROS(1,16);
SS=ZEROS(1,16);
K_GN=ZEROS(DM,16);
P_CF=ZEROS(DM,16);
P_VR=ZEROS(DM,16*DM);
PR_VL=ZEROS(1,16);

LIKV=0.0;
J_ITER = jj_iter;
DO UNTIL J_ITER>T;

  J=1;
  S1t=0; DO UNTIL S1t>1;
  S2t=0; DO UNTIL S2t>1;
  S1tl=0;DO UNTIL S1tl>1;
  S2tl=0;DO UNTIL S2tl>1;

     IF S1tl==0 AND S2tl==0; P_C12_=P_C12_00;P_V12_=P_V12_00;
 ELSEIF S1tl==0 AND S2tl==1; P_C12_=P_C12_01;P_V12_=P_V12_01;
 ELSEIF S1tl==1 AND S2tl==0; P_C12_=P_C12_10;P_V12_=P_V12_10;
 ELSEIF S1tl==1 AND S2tl==1; P_C12_=P_C12_11;P_V12_=P_V12_11;ENDIF;

PST_CF[.,J] = AAA * P_C12_ ;

         QQ=  (Se_M[.,S2t+1]~0)|(0~0);

PST_VR[.,(J-1)*DM+1:(J-1)*DM+DM]=AAA*P_V12_*AAA'+QQ;

F_CAST[.,J]=YY[J_ITER,.] -H*PST_CF[.,J]- mu ;

SS[.,J]= H * PST_VR[.,(J-1)*DM+1:(J-1)*DM+DM] * H' + Sv_M[.,S1t+1];

K_GN[.,J] =PST_VR[.,(J-1)*DM+1:(J-1)*DM+DM] * H' / SS[.,J];
P_CF[.,J] = PST_CF[.,J] + K_GN[.,J] * F_CAST[.,J];
P_VR[.,(J-1)*DM+1:(J-1)*DM+DM]=(EYE(DM)-K_GN[.,J]*H)*
                                            PST_VR[.,(J-1)*DM+1:(J-1)*DM+DM];

            IF     S1t==1 AND S1tl==1; PR_TR1=PPR1;  PRO1__=PRO1__1;
            ELSEIF S1t==1 AND S1tl==0; PR_TR1=1-QPR1;PRO1__=PRO1__0;
            ELSEIF S1t==0 AND S1tl==1; PR_TR1=1-PPR1;PRO1__=PRO1__1;
            ELSEIF S1t==0 AND S1tl==0; PR_TR1=QPR1;  PRO1__=PRO1__0;ENDIF;

            IF S2t==1 AND S2tl==1; PR_TR2=PPR2;  PRO2__ =PRO2__1;
        ELSEIF S2t==1 AND S2tl==0; PR_TR2=1-QPR2;PRO2__=PRO2__0;
        ELSEIF S2t==0 AND S2tl==1; PR_TR2=1-PPR2;PRO2__=PRO2__1;
        ELSEIF S2t==0 AND S2tl==0; PR_TR2=QPR2;  PRO2__ =PRO2__0;ENDIF;

PR_VL[.,J]=V_PROB(F_CAST[.,J],SS[.,J])*PR_TR1*PRO1__*PR_TR2*PRO2__;

        J=J+1;
    S2tl=S2tl+1; ENDO;
    S1tl=S1tl+1;ENDO;
    S2t=S2t+1; ENDO;
    S1t=S1t+1; ENDO;


@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@

PR_VAL=SUMC(PR_VL');
PRO_=PR_VL/PR_VAL;    @Pr[S1t,S2t,S1tl,S2tl|Y_t-1]@

PRO1_00=PRO_[.,1]+PRO_[.,2]+PRO_[.,5]+PRO_[.,6];
PRO1_10=PRO_[.,3]+PRO_[.,4]+PRO_[.,7]+PRO_[.,8];
PRO1_01=PRO_[.,9]+PRO_[.,10]+PRO_[.,13]+PRO_[.,14];
PRO1_11=PRO_[.,11]+PRO_[.,12]+PRO_[.,15]+PRO_[.,16];  @Pr[S1tl,S1t|Y_t]@

PRO2_00=PRO_[.,1]+PRO_[.,3]+PRO_[.,9]+PRO_[.,11];
PRO2_10=PRO_[.,2]+PRO_[.,4]+PRO_[.,10]+PRO_[.,12];
PRO2_01=PRO_[.,5]+PRO_[.,7]+PRO_[.,13]+PRO_[.,15];
PRO2_11=PRO_[.,6]+PRO_[.,8]+PRO_[.,14]+PRO_[.,16];    @Pr[S2tl,S2t|Y_t]@

PRO12_00=SUMC(PRO_[.,1:4]');
PRO12_01=SUMC(PRO_[.,5:8]');
PRO12_10=SUMC(PRO_[.,9:12]');
PRO12_11=SUMC(PRO_[.,13:16]');             @Pr[S1t,S2t|Y_t]@


LIK=-1*LN(PR_VAL);

        PRO1__0=PRO1_00+PRO1_10;         @Pr[S1t=0/Yt]@
        PRO1__1=PRO1_01+PRO1_11;         @Pr[S1t=1/Yt]@

        PRO2__0=PRO2_00+PRO2_10;         @Pr[S2t=0/Yt]@
        PRO2__1=PRO2_01+PRO2_11;         @Pr[S2t=1/Yt]@
@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<@

P_C12_00=(PRO_[.,1]*P_CF[.,1] +PRO_[.,2]*P_CF[.,2] +
          PRO_[.,3]*P_CF[.,3] +PRO_[.,4]*P_CF[.,4])/PRO12_00;
P_C12_01=(PRO_[.,5]*P_CF[.,5] +PRO_[.,6]*P_CF[.,6] +
          PRO_[.,7]*P_CF[.,7] +PRO_[.,8]*P_CF[.,8])/PRO12_01;
P_C12_10=(PRO_[.,9]*P_CF[.,9] +PRO_[.,10]*P_CF[.,10] +
          PRO_[.,11]*P_CF[.,11] +PRO_[.,12]*P_CF[.,12])/PRO12_10;
P_C12_11=(PRO_[.,13]*P_CF[.,13] +PRO_[.,14]*P_CF[.,14] +
          PRO_[.,15]*P_CF[.,15] +PRO_[.,16]*P_CF[.,16])/PRO12_11;

P_V12_00=(PRO_[.,1]*(P_VR[.,(1-1)*DM+1:(1-1)*DM+DM]+
                         (P_C12_00-P_CF[.,1])*(P_C12_00-P_CF[.,1])')+
          PRO_[.,2]*(P_VR[.,(2-1)*DM+1:(2-1)*DM+DM]+
                         (P_C12_00-P_CF[.,2])*(P_C12_00-P_CF[.,2])')+
      PRO_[.,3]*(P_VR[.,(3-1)*DM+1:(3-1)*DM+DM]+
                         (P_C12_00-P_CF[.,3])*(P_C12_00-P_CF[.,3])')+
      PRO_[.,4]*(P_VR[.,(4-1)*DM+1:(4-1)*DM+DM]+
                         (P_C12_00-P_CF[.,4])*(P_C12_00-P_CF[.,4])'))/PRO12_00;

P_V12_01=(PRO_[.,5]*(P_VR[.,(5-1)*DM+1:(5-1)*DM+DM]+
                         (P_C12_01-P_CF[.,5])*(P_C12_01-P_CF[.,5])')+
          PRO_[.,6]*(P_VR[.,(6-1)*DM+1:(6-1)*DM+DM]+
                         (P_C12_01-P_CF[.,6])*(P_C12_01-P_CF[.,6])')+
      PRO_[.,7]*(P_VR[.,(7-1)*DM+1:(7-1)*DM+DM]+
                         (P_C12_01-P_CF[.,7])*(P_C12_01-P_CF[.,7])')+
      PRO_[.,8]*(P_VR[.,(8-1)*DM+1:(8-1)*DM+DM]+
                         (P_C12_01-P_CF[.,8])*(P_C12_01-P_CF[.,8])'))/PRO12_01;

P_V12_10=(PRO_[.,9]*(P_VR[.,(9-1)*DM+1:(9-1)*DM+DM]+
                         (P_C12_10-P_CF[.,9])*(P_C12_10-P_CF[.,9])')+
          PRO_[.,10]*(P_VR[.,(10-1)*DM+1:(10-1)*DM+DM]+
                         (P_C12_10-P_CF[.,10])*(P_C12_10-P_CF[.,10])')+
      PRO_[.,11]*(P_VR[.,(11-1)*DM+1:(11-1)*DM+DM]+
                         (P_C12_10-P_CF[.,11])*(P_C12_10-P_CF[.,11])')+
      PRO_[.,12]*(P_VR[.,(12-1)*DM+1:(12-1)*DM+DM]+
                       (P_C12_10-P_CF[.,12])*(P_C12_10-P_CF[.,12])'))/PRO12_10;

P_V12_11=(PRO_[.,13]*(P_VR[.,(13-1)*DM+1:(13-1)*DM+DM]+
                       (P_C12_11-P_CF[.,13])*(P_C12_11-P_CF[.,13])')+
      PRO_[.,14]*(P_VR[.,(14-1)*DM+1:(14-1)*DM+DM]+
                       (P_C12_11-P_CF[.,14])*(P_C12_11-P_CF[.,14])')+
      PRO_[.,15]*(P_VR[.,(15-1)*DM+1:(15-1)*DM+DM]+
                       (P_C12_11-P_CF[.,15])*(P_C12_11-P_CF[.,15])')+
      PRO_[.,16]*(P_VR[.,(16-1)*DM+1:(16-1)*DM+DM]+
                       (P_C12_11-P_CF[.,16])*(P_C12_11-P_CF[.,16])'))/PRO12_11;



IF J_ITER < START; goto skip; endif;
LIKV = LIKV+LIK;
skip:  J_ITER = J_ITER+1;
ENDO;
               LOCATE 2,35;"LIKV=";;LIKV;
RETP(LIKV);
ENDP;

@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@
PROC TRANS(coef0); @ constraining values of reg. coeff.@
   local coef1,m,u,XX9,XX10;
      u=0.999999999;
      m=0.000000001;
   coef1=coef0;

   coef1[1:4,.]=m+(u-m)./ (1+exp(-1*coef0[1:4,.]));
   coef1[5:8,.]=exp(-1*coef0[5:8,.]);

      XX9 =coef0[9,1]/(1+abs(coef0[9,1]));
      XX10 = coef0[10,1]/(1+abs(coef0[10,1]));
      coef1[9,1] = XX9 + XX10 ;
      coef1[10,1] =-1*XX9*XX10 ;


   retp(coef1);
endp;
@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<@

PROC TRAN_INV(coef0);
    local coef1,m,u;
       u=0.999999999;
       m=0.000000001;
coef1=coef0;
    coef1[6:7,1]=sqrt(coef0[6:7,1]-m);
    coef1[1:4,.]=-1*ln((u-coef0[1:4,.]) ./ (coef0[1:4,.]-m));

    retp(coef1);
endp;
@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@
PROC V_PROB(EV, HE);      @ CALCULATES    Pr[Yt/St,Yt-1]@
LOCAL VAL;
VAL=(1/SQRT(2*PI*HE))*EXP(-0.5*EV*EV/HE);
RETP(VAL);
ENDP;



@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<@

PROC (4) = LIK_out(PRMTR1);

LOCAL PPR1,PPR2,QPR1,QPR2,PHI,SV0,SE0,AV0,AE0,DD,BETA1,BETA2,AAA,H,PRO1__1,
      PRO1__0,PRO2__0,PRO2__1,P_C12_,P_C12_00,P_C12_01,P_C12_10,P_C12_11,
      P_V12_,P_V12_00,P_V12_01,P_V12_10,P_V12_11,SV_M,SE_M,PST_CF,PST_VR,
      F_CAST,SS,K_GN,P_CF,P_VR,PR_VL,LIKV,J_ITER,J,LIK,S1t,S2t,S1tl,S2tl,
      PR_VAL,PRO_,PRO1_00,PRO1_01,PRO1_10,PRO1_11,PRO2_00,PRO2_01,PRO2_10,
      PRO2_11,PRO12_00,PRO12_01,PRO12_10,PRO12_11,PRMTR,PR_TR1,PR_TR2,
      PRO2__,PRO1__,DD1,DD2,DD3,DD4,MU,MU_L,AR1,AR2,QQ,QQ_S,PRIOR_VR,VECP,
      mu_m, xttl_m,pttl_m,pr_st2,pr_st1,ptm_t,qq_ss,vecp,ratio_m;

EXTERNAL PROC TRANS, V_PROB;

        xttl_m=zeros(t,1);      @stores E[X_t|Y_t-1]@
    pttl_m=zeros(t,1);  @stores VAR[X_t|Y_T-1]@
    pr_st1=zeros(t,1); @stores PR[S1t=1|Y_t-1]@
    pr_st2=zeros(t,1); @stores PR[S2t=1|Y_t-1]@
    ratio_m=zeros(t,1);

PRMTR=PRMTR1;

PPR1=PRMTR[1,1];    @Pr[St=1/St-1=1]@
QPR1=PRMTR[2,1];    @Pr[St=0/St-1=0]@
PPR2=PRMTR[3,1];
QPR2=PRMTR[4,1];
SV0=PRMTR[5,1];
SE0=PRMTR[6,1];
AV0=PRMTR[7,1];
AE0=PRMTR[8,1];
AR1=PRMTR[9,1];
AR2=PRMTR[10,1];
mu=prmtr[11,1];
mu_m=mu;


AAA=(ar1~ar2)|
    (1~0);
H=1~-1;

@>>>>>>>>>>>>>>>>>>>>>>>>>  INITIAL PROB. Pr[S0/Y0] @

        PRO1__1=(1-QPR1)/(2-PPR1-QPR1);   @Pr[St-1=1/Yt-1], STEADY STATE PROB.@
        PRO1__0=1-PRO1__1  ;           @Pr[ST-1=0/Yt-1], STEADY STATE PROB @

        PRO2__1=(1-QPR2)/(2-PPR2-QPR2);   @Pr[St-1=1/Yt-1], STEADY STATE PROB.@
        PRO2__0=1-PRO2__1  ;           @Pr[ST-1=0/Yt-1], STEADY STATE PROB @


SV_M=(SV0^2~AV0^2);
SE_M=(SE0^2~AE0^2);

P_C12_00=zeros(dM,1);
P_C12_01=ZEROS(DM,1);
P_C12_10=ZEROS(DM,1);
P_C12_11=ZEROS(DM,1);


         QQ_ss=  ((se0^2*pro2__0 + ae0^2*pro2__1)~0)|(0~0);
         vecp=inv(eye(4)-aaa.*.aaa)*vec(QQ_ss);
     prior_vr=vecp[1:2,1]~vecp[3:4,1];

  P_V12_00=prior_vr;
  P_V12_01=prior_vr;
  P_V12_10=prior_vr;
  P_V12_11=prior_vr;

PST_CF=ZEROS(DM,16);
PST_VR=ZEROS(DM,16*DM);

F_CAST=ZEROS(1,16);
SS=ZEROS(1,16);
K_GN=ZEROS(DM,16);
P_CF=ZEROS(DM,16);
P_VR=ZEROS(DM,16*DM);
PR_VL=ZEROS(1,16);

LIKV=0.0;
J_ITER = jj_iter;
DO UNTIL J_ITER>T;

  J=1;
  S1t=0; DO UNTIL S1t>1;
  S2t=0; DO UNTIL S2t>1;
  S1tl=0;DO UNTIL S1tl>1;
  S2tl=0;DO UNTIL S2tl>1;

     IF S1tl==0 AND S2tl==0; P_C12_=P_C12_00;P_V12_=P_V12_00;
 ELSEIF S1tl==0 AND S2tl==1; P_C12_=P_C12_01;P_V12_=P_V12_01;
 ELSEIF S1tl==1 AND S2tl==0; P_C12_=P_C12_10;P_V12_=P_V12_10;
 ELSEIF S1tl==1 AND S2tl==1; P_C12_=P_C12_11;P_V12_=P_V12_11;ENDIF;

PST_CF[.,J] = AAA * P_C12_ ;

         QQ=  (Se_M[.,S2t+1]~0)|(0~0);

PST_VR[.,(J-1)*DM+1:(J-1)*DM+DM]=AAA*P_V12_*AAA'+QQ;

F_CAST[1,J]=YY[J_ITER,1] -H*PST_CF[.,J]-mu ;

SS[.,J]= H * PST_VR[.,(J-1)*DM+1:(J-1)*DM+DM] * H' + Sv_M[.,S1t+1];

K_GN[.,J] =PST_VR[.,(J-1)*DM+1:(J-1)*DM+DM] * H' / SS[.,J];
P_CF[.,J] = PST_CF[.,J] + K_GN[.,J] * F_CAST[.,J];
P_VR[.,(J-1)*DM+1:(J-1)*DM+DM]=(EYE(DM)-K_GN[.,J]*H)*
                                            PST_VR[.,(J-1)*DM+1:(J-1)*DM+DM];

            IF     S1t==1 AND S1tl==1; PR_TR1=PPR1;  PRO1__=PRO1__1;
            ELSEIF S1t==1 AND S1tl==0; PR_TR1=1-QPR1;PRO1__=PRO1__0;
            ELSEIF S1t==0 AND S1tl==1; PR_TR1=1-PPR1;PRO1__=PRO1__1;
            ELSEIF S1t==0 AND S1tl==0; PR_TR1=QPR1;  PRO1__=PRO1__0;ENDIF;

            IF S2t==1 AND S2tl==1; PR_TR2=PPR2;  PRO2__ =PRO2__1;
        ELSEIF S2t==1 AND S2tl==0; PR_TR2=1-QPR2;PRO2__=PRO2__0;
        ELSEIF S2t==0 AND S2tl==1; PR_TR2=1-PPR2;PRO2__=PRO2__1;
        ELSEIF S2t==0 AND S2tl==0; PR_TR2=QPR2;  PRO2__ =PRO2__0;ENDIF;

PR_VL[.,J]=V_PROB(F_CAST[.,J],SS[.,J])*PR_TR1*PRO1__*PR_TR2*PRO2__;

        J=J+1;
    S2tl=S2tl+1; ENDO;
    S1tl=S1tl+1;ENDO;
    S2t=S2t+1; ENDO;
    S1t=S1t+1; ENDO;


@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@

PR_VAL=SUMC(PR_VL');
PRO_=PR_VL/PR_VAL;    @Pr[S1t,S2t,S1tl,S2tl|Y_t]@

xttl_m[j_iter,1]=sumc(pro_'.* p_cf[1,.]');
                      @ E(Xt|Y_t-1]  trend component @

/*     ptm_t=p_vr[1,1]~p_vr[1,4]~p_vr[1,7]~p_vr[1,10]~p_vr[1,13]~p_vr[1,16]~
           p_vr[1,19]~p_vr[1,22]~p_vr[1,25]~p_vr[1,28]~p_vr[1,31]~p_vr[1,34]~
       p_vr[1,37]~p_vr[1,40]~p_vr[1,43]~p_vr[1,46];
                  @ Var(X_t|Y_t-1, S1t,s2t,s2_t-1,s1_t-1)@

pttl_m[j_iter,1]=sumc(PRO_'.*(ptm_t'+
     (xttl_m[j_iter,1]-P_CF[1,.]').*(xttl_m[j_iter,1]-P_CF[1,.]')));

  */

PRO1_00=PRO_[.,1]+PRO_[.,2]+PRO_[.,5]+PRO_[.,6];
PRO1_10=PRO_[.,3]+PRO_[.,4]+PRO_[.,7]+PRO_[.,8];
PRO1_01=PRO_[.,9]+PRO_[.,10]+PRO_[.,13]+PRO_[.,14];
PRO1_11=PRO_[.,11]+PRO_[.,12]+PRO_[.,15]+PRO_[.,16];  @Pr[S1tl,S1t|Y_t]@

PRO2_00=PRO_[.,1]+PRO_[.,3]+PRO_[.,9]+PRO_[.,11];
PRO2_10=PRO_[.,2]+PRO_[.,4]+PRO_[.,10]+PRO_[.,12];
PRO2_01=PRO_[.,5]+PRO_[.,7]+PRO_[.,13]+PRO_[.,15];
PRO2_11=PRO_[.,6]+PRO_[.,8]+PRO_[.,14]+PRO_[.,16];    @Pr[S2tl,S2t|Y_t]@

PRO12_00=SUMC(PRO_[.,1:4]');
PRO12_01=SUMC(PRO_[.,5:8]');
PRO12_10=SUMC(PRO_[.,9:12]');
PRO12_11=SUMC(PRO_[.,13:16]');             @Pr[S1t,S2t|Y_t]@


LIK=-1*LN(PR_VAL);

        PRO1__0=PRO1_00+PRO1_10;         @Pr[S1t=0/Yt]@
        PRO1__1=PRO1_01+PRO1_11;         @Pr[S1t=1/Yt]@

        PRO2__0=PRO2_00+PRO2_10;         @Pr[S2t=0/Yt]@
        PRO2__1=PRO2_01+PRO2_11;         @Pr[S2t=1/Yt]@
@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<@

        pr_st1[j_iter,1]=pro1__1;
    pr_st2[j_iter,1]=pro2__1;

ratio_m[j_iter,1]=sqrt((pro2__0*se0^2+pro2__1*ae0^2)
                      /(pro1__0*sv0^2+pro1__1*av0^2));


P_C12_00=(PRO_[.,1]*P_CF[.,1] +PRO_[.,2]*P_CF[.,2] +
          PRO_[.,3]*P_CF[.,3] +PRO_[.,4]*P_CF[.,4])/PRO12_00;
P_C12_01=(PRO_[.,5]*P_CF[.,5] +PRO_[.,6]*P_CF[.,6] +
          PRO_[.,7]*P_CF[.,7] +PRO_[.,8]*P_CF[.,8])/PRO12_01;
P_C12_10=(PRO_[.,9]*P_CF[.,9] +PRO_[.,10]*P_CF[.,10] +
          PRO_[.,11]*P_CF[.,11] +PRO_[.,12]*P_CF[.,12])/PRO12_10;
P_C12_11=(PRO_[.,13]*P_CF[.,13] +PRO_[.,14]*P_CF[.,14] +
          PRO_[.,15]*P_CF[.,15] +PRO_[.,16]*P_CF[.,16])/PRO12_11;

P_V12_00=(PRO_[.,1]*(P_VR[.,(1-1)*DM+1:(1-1)*DM+DM]+
                         (P_C12_00-P_CF[.,1])*(P_C12_00-P_CF[.,1])')+
          PRO_[.,2]*(P_VR[.,(2-1)*DM+1:(2-1)*DM+DM]+
                         (P_C12_00-P_CF[.,2])*(P_C12_00-P_CF[.,2])')+
      PRO_[.,3]*(P_VR[.,(3-1)*DM+1:(3-1)*DM+DM]+
                         (P_C12_00-P_CF[.,3])*(P_C12_00-P_CF[.,3])')+
      PRO_[.,4]*(P_VR[.,(4-1)*DM+1:(4-1)*DM+DM]+
                         (P_C12_00-P_CF[.,4])*(P_C12_00-P_CF[.,4])'))/PRO12_00;

P_V12_01=(PRO_[.,5]*(P_VR[.,(5-1)*DM+1:(5-1)*DM+DM]+
                         (P_C12_01-P_CF[.,5])*(P_C12_01-P_CF[.,5])')+
          PRO_[.,6]*(P_VR[.,(6-1)*DM+1:(6-1)*DM+DM]+
                         (P_C12_01-P_CF[.,6])*(P_C12_01-P_CF[.,6])')+
      PRO_[.,7]*(P_VR[.,(7-1)*DM+1:(7-1)*DM+DM]+
                         (P_C12_01-P_CF[.,7])*(P_C12_01-P_CF[.,7])')+
      PRO_[.,8]*(P_VR[.,(8-1)*DM+1:(8-1)*DM+DM]+
                         (P_C12_01-P_CF[.,8])*(P_C12_01-P_CF[.,8])'))/PRO12_01;

P_V12_10=(PRO_[.,9]*(P_VR[.,(9-1)*DM+1:(9-1)*DM+DM]+
                         (P_C12_10-P_CF[.,9])*(P_C12_10-P_CF[.,9])')+
          PRO_[.,10]*(P_VR[.,(10-1)*DM+1:(10-1)*DM+DM]+
                         (P_C12_10-P_CF[.,10])*(P_C12_10-P_CF[.,10])')+
      PRO_[.,11]*(P_VR[.,(11-1)*DM+1:(11-1)*DM+DM]+
                         (P_C12_10-P_CF[.,11])*(P_C12_10-P_CF[.,11])')+
      PRO_[.,12]*(P_VR[.,(12-1)*DM+1:(12-1)*DM+DM]+
                       (P_C12_10-P_CF[.,12])*(P_C12_10-P_CF[.,12])'))/PRO12_10;

P_V12_11=(PRO_[.,13]*(P_VR[.,(13-1)*DM+1:(13-1)*DM+DM]+
                       (P_C12_11-P_CF[.,13])*(P_C12_11-P_CF[.,13])')+
      PRO_[.,14]*(P_VR[.,(14-1)*DM+1:(14-1)*DM+DM]+
                       (P_C12_11-P_CF[.,14])*(P_C12_11-P_CF[.,14])')+
      PRO_[.,15]*(P_VR[.,(15-1)*DM+1:(15-1)*DM+DM]+
                       (P_C12_11-P_CF[.,15])*(P_C12_11-P_CF[.,15])')+
      PRO_[.,16]*(P_VR[.,(16-1)*DM+1:(16-1)*DM+DM]+
                       (P_C12_11-P_CF[.,16])*(P_C12_11-P_CF[.,16])'))/PRO12_11;



IF J_ITER < START; goto skip; endif;
LIKV = LIKV+LIK;
skip:  J_ITER = J_ITER+1;
ENDO;
RETP(xttl_m,pr_st1,pr_st2,ratio_m);
ENDP;


@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@

/*       S1t          S2t           S1tl        S2tl
    0.000000     0.000000     0.000000     0.000000
    0.000000     0.000000     0.000000     1.000000
    0.000000     0.000000     1.000000     0.000000
    0.000000     0.000000     1.000000     1.000000
    0.000000     1.000000     0.000000     0.000000
    0.000000     1.000000     0.000000     1.000000
    0.000000     1.000000     1.000000     0.000000
    0.000000     1.000000     1.000000     1.000000
    1.000000     0.000000     0.000000     0.000000
    1.000000     0.000000     0.000000     1.000000
    1.000000     0.000000     1.000000     0.000000
    1.000000     0.000000     1.000000     1.000000
    1.000000     1.000000     0.000000     0.000000
    1.000000     1.000000     0.000000     1.000000
    1.000000     1.000000     1.000000     0.000000
    1.000000     1.000000     1.000000     1.000000 */

